#!/usr/bin/python

#allows you to capture the command switches
import sys

#get serial features for python
import serial

#this next line sets up the serial port to allow for communication
#and opens the serial port you may need to change
#ttyS0 to S1, S2, ect. The rest shouldn't need to change.

ser = serial.Serial('/dev/ttyUSB0', 9600, 8, serial.PARITY_NONE,serial.STOPBITS_ONE, xonxoff=0, rtscts=0, timeout=1)

#default COMMAND is bogus
COMMAND = "nope"
aspect169 = "kc 01 02"
aspect43 = "kc 01 01"
poweron = "ka 01 01"
poweroff = "ka 01 00"
inputdtv = "kb 01 00"
input = "mc 01 0b"
inputav1 = "mc 01 d5"
inputcomp1 = "mc 01 04"
inputpc = "mc 01 d5"
muteon = "ke 01 00"
muteoff = "ke 01 01"
volume = "kf 01 "
volup = "mc 01 02"
voldown = "mc 01 03"
menu =  "mc 01 43"
enter = "mc 01 44"
sleep = "mc 01 ba"
back = "mc 01 28"
exit = "mc 01 5b"
up = "mc 01 40"
down = "mc 01 41"
left = "mc 01 07"
right = "mc 01 06"

num0 = "mc 01 10"
num1 = "mc 01 11"
num2 = "mc 01 12"
num3 = "mc 01 13"
num4 = "mc 01 14"
num5 = "mc 01 15"
num6 = "mc 01 16"
num7 = "mc 01 17"
num8 = "mc 01 18"
num9 = "mc 01 19"

pause = "mc 01 0e"
hdmi1 = "xb 01 90"
hdmi2 = "xb 01 91"
hdmi3 = "xb 01 92"
hdmi4 = "xb 01 93"

if sys.argv[1:] == ['--sleep'] :
   COMMAND = sleep

if sys.argv[1:] == ['--volup'] :
   COMMAND = volup

if sys.argv[1:] == ['--voldown'] :
   COMMAND = voldown

if sys.argv[1:] == ['--menu'] :
   COMMAND = menu

if sys.argv[1:] == ['--enter'] :
   COMMAND = enter

if sys.argv[1:] == ['--back'] :
   COMMAND = back

if sys.argv[1:] == ['--exit'] :
   COMMAND = exit

if sys.argv[1:] == ['--up'] :
   COMMAND = up

if sys.argv[1:] == ['--down'] :
   COMMAND = down

if sys.argv[1:] == ['--left'] :
   COMMAND = left

if sys.argv[1:] == ['--right'] :
   COMMAND = right

if sys.argv[1:] == ['--num0'] :
   COMMAND = num0

if sys.argv[1:] == ['--num1'] :
   COMMAND = num1

if sys.argv[1:] == ['--num2'] :
   COMMAND = num2

if sys.argv[1:] == ['--num3'] :
   COMMAND = num3

if sys.argv[1:] == ['--num4'] :
   COMMAND = num4

if sys.argv[1:] == ['--num5'] :
   COMMAND = num5

if sys.argv[1:] == ['--num6'] :
   COMMAND = num6

if sys.argv[1:] == ['--num7'] :
   COMMAND = num7

if sys.argv[1:] == ['--num8'] :
   COMMAND = num8

if sys.argv[1:] == ['--num9'] :
   COMMAND = num9

if sys.argv[1:] == ['--pause'] :
   COMMAND = pause

if sys.argv[1:] == ['--hdmi1'] :
   COMMAND = hdmi1

if sys.argv[1:] == ['--hdmi2'] :
   COMMAND = hdmi2

if sys.argv[1:] == ['--hdmi3'] :
   COMMAND = hdmi3

if sys.argv[1:] == ['--hdmi4'] :
   COMMAND = hdmi4



if sys.argv[1:] == ['--aspect169'] :
   COMMAND = aspect169

if sys.argv[1:] == ['--aspect43'] :
   COMMAND = aspect43

if sys.argv[1:] == ['--poweron'] :
   COMMAND = poweron

if sys.argv[1:] == ['--poweroff'] :
   COMMAND = poweroff

if sys.argv[1:] == ['--inputdtv'] :
   COMMAND = inputdtv

if sys.argv[1:] == ['--input'] :
   COMMAND = input

if sys.argv[1:] == ['--inputav1'] :
   COMMAND = inputav1

if sys.argv[1:] == ['--inputcomp1'] :
   COMMAND = inputcomp1

if sys.argv[1:] == ['--inputpc'] :
   COMMAND = inputpc

if sys.argv[1:] == ['--muteon'] :
   COMMAND = muteon

if sys.argv[1:] == ['--muteoff'] :
   COMMAND = muteoff

if sys.argv[1:2] == ['--volume'] :
   COMMAND = volume
   szahl = str(sys.argv[2:3])
   #print szahl
   if szahl == '[]' :
      szahl='[.255.]'
   zlong=len(szahl)-2
   zahlin=szahl[2:zlong]
   #print zahlin
   izahl=int(zahlin)
   #print izahl
   hexzahl=format(izahl, 'x')
   #print hexzahl
   hexstring=hexzahl.zfill(2)
   #print hexstring
   if izahl > 100 :
      hexstring='ff'
   COMMAND=COMMAND+hexstring
   #print COMMAND

if sys.argv[1:] == ['--hdmi1'] :
   COMMAND = hdmi1

if sys.argv[1:] == ['--hdmi2'] :
   COMMAND = hdmi2

if sys.argv[1:] == ['--hdmi3'] :
   COMMAND = hdmi3

if sys.argv[1:] == ['--hdmi4'] :
   COMMAND = hdmi4







#This is when it actually writes the command to the serial port.
#ser.write(bytes(COMMAND+'\r', encoding = 'ascii'))
ser.write(COMMAND+'\r')

if sys.argv[1:2] == ['--volume'] :
   msg = ser.read(size=1024)
   msgl=len(msg)
   myhexvolume = msg[msgl-3:msgl-1]
   myvolume = int(myhexvolume, 16)
   print 'volume '+str(myvolume)

ser.close()
#all done now close the port.
#ser.close()